Index: issm/trunk/src/c/solutionsequences/solutionsequence_sampling.cpp
===================================================================
--- issm/trunk/src/c/solutionsequences/solutionsequence_sampling.cpp	(revision 26744)
+++ issm/trunk/src/c/solutionsequences/solutionsequence_sampling.cpp	(revision 26744)
@@ -0,0 +1,148 @@
+/*!\file: solutionsequence_sampling.cpp
+ * \brief: numerical core of linear solutions
+ */
+
+#include "../toolkits/toolkits.h"
+#include "../classes/classes.h"
+#include "../shared/shared.h"
+#include "../modules/modules.h"
+#include "../analyses/analyses.h"
+#include "../shared/Random/randomgenerator.h"
+//#include <random>
+
+void GaussianVector(Vector<IssmDouble>* ppf,int seed){/*{{{*/
+
+
+	/*Intermediaries*/
+	double      rdnumber;
+
+	/*Define seed*/
+	rnd::linear_congruential_engine random_engine;
+	if(seed>=0)
+	{
+		int my_rank;
+		ISSM_MPI_Comm_rank(ISSM_MPI_COMM_WORLD,&my_rank);
+		seed = seed + 783728*my_rank; // change default seed for parallel simulations (by considering an arbitrary shif based on the rank number)
+	}
+	random_engine.seed(seed);
+
+	/* Define univariate distribution */
+
+	rnd::normal_distribution distribution(0.0,1.0);
+
+	int        *local_indices = NULL;
+	IssmDouble *local_vector = NULL;
+	ppf->GetLocalVector(&local_vector,&local_indices);
+
+  int M;
+	ppf->GetLocalSize(&M);
+	for(int i=0;i<M;i++){
+		rdnumber = distribution.generator(random_engine);
+		ppf->SetValue(local_indices[i],rdnumber,INS_VAL);
+	}
+	ppf->Assemble();
+
+}/*}}}*/
+void solutionsequence_sampling(FemModel* femmodel){
+
+	/*intermediary: */
+  Matrix<IssmDouble>*  Kff = NULL;
+	Matrix<IssmDouble>*  Kfs = NULL;
+  Vector<IssmDouble>*  ug  = NULL;
+  Vector<IssmDouble>*  uf  = NULL;
+  Vector<IssmDouble>*  old_uf  = NULL;     // previous solution vector (for transient)
+  Vector<IssmDouble>*  pf  = NULL;
+  Vector<IssmDouble>*  df  = NULL;
+  Vector<IssmDouble>*  ys=NULL;
+
+  SamplingAnalysis*    analysis = NULL;
+
+  Vector<IssmDouble>*  Ml = NULL;      // diagonal lumped mass matrix
+  Vector<IssmDouble>*  Mscale = NULL;  // square root of diagonal lumped factor matrix
+
+  /*parameters:*/
+  int solution_type, alpha, step, seed, nsize;
+  IssmDouble phi, tau;
+
+  /*Recover parameters: */
+  femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
+  femmodel->parameters->FindParam(&seed,SamplingSeedEnum);
+  femmodel->parameters->FindParam(&alpha,SamplingAlphaEnum);
+  femmodel->parameters->FindParam(&tau,SamplingTauEnum);
+
+  /*Recover parameters for transient simulation: */
+  if(solution_type==TransientSolutionEnum)
+  {
+    femmodel->parameters->FindParam(&step,StepEnum);
+    femmodel->parameters->FindParam(&phi,SamplingPhiEnum);
+		if(seed>=0) seed = seed + 13923272*step; // change default seed for transient simulations (by considering an arbitrary shif based on the step number)
+
+    GetSolutionFromInputsx(&ug,femmodel);
+    Reducevectorgtofx(&uf, ug, femmodel->nodes,femmodel->parameters);
+    old_uf=uf->Duplicate();
+  }
+
+  /*CreateAnalysis*/
+
+  analysis = new SamplingAnalysis();
+
+  analysis->LumpedMassMatrix(&Ml,femmodel); //Create lumped mass matrix
+
+  if(alpha%2!=0)  analysis->LumpedKMatrix(&Mscale,femmodel);   /* Compute square root of lump mass matrix (for alpha even) or stiffness matrix (for alpha odd) */
+  else{
+    Mscale=Ml->Duplicate();
+    Ml->Copy(Mscale);
+  }
+  Mscale->Pow(0.5);
+
+  femmodel->UpdateConstraintsx();
+  SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL,femmodel);
+  CreateNodalConstraintsx(&ys,femmodel->nodes);
+  Reduceloadx(pf, Kfs, ys);
+  delete Kfs;
+
+  /*Copy old solution for transient run */
+  if(solution_type==TransientSolutionEnum) uf->Copy(old_uf);
+
+  /* Generate random RHS */
+  GaussianVector(pf,seed);
+
+  /* Multiply random RHS by square root of mass matrix (for alpha even) or stiffness matrix (for alpha odd) */
+  pf->PointwiseMult(pf,Mscale);
+
+  /*Go solve SPDE */
+  femmodel->profiler->Start(SOLVER);
+  Solverx(&uf, Kff, pf, NULL, df, femmodel->parameters);
+  femmodel->profiler->Stop(SOLVER);
+
+  /* Iterate to compute a realization for alpha>2 */
+  for(int i=3;i<=alpha;i+=2){
+
+    /*Create RHS */
+    uf->Copy(pf);
+    pf->PointwiseMult(pf,Ml);
+
+    /*Go solve SPDE */
+    femmodel->profiler->Start(SOLVER);
+    Solverx(&uf, Kff, pf, NULL, df, femmodel->parameters);
+    femmodel->profiler->Stop(SOLVER);
+
+  }
+
+  /* Divide results by tau */
+  uf->Scale(1.0/tau);
+
+  /* Update solution x_{t+1} = phi x_{t} + noise for transient */
+  if(solution_type==TransientSolutionEnum) uf->AXPY(old_uf,phi);
+
+  /* Update input */
+  Mergesolutionfromftogx(&ug, uf,ys,femmodel->nodes,femmodel->parameters);
+  InputUpdateFromSolutionx(femmodel,ug);
+
+  /*clean-up*/
+  delete Kff; delete pf; delete df; delete uf; delete ys; delete old_uf;
+  delete Ml; delete Mscale;
+  delete analysis;
+  delete ug;
+
+}
Index: issm/trunk/src/c/solutionsequences/solutionsequences.h
===================================================================
--- issm/trunk/src/c/solutionsequences/solutionsequences.h	(revision 25994)
+++ issm/trunk/src/c/solutionsequences/solutionsequences.h	(revision 26744)
@@ -1,4 +1,4 @@
 /*
- * solutionsequences.h: 
+ * solutionsequences.h:
  */
 
@@ -25,4 +25,5 @@
 void solutionsequence_adjoint_linear(FemModel* femmodel);
 void solutionsequence_schurcg(FemModel* femmodel);
+void solutionsequence_sampling(FemModel* femmodel);
 
 /*convergence*/
Index: issm/trunk/src/c/toolkits/ToolkitOptions.cpp
===================================================================
--- issm/trunk/src/c/toolkits/ToolkitOptions.cpp	(revision 25994)
+++ issm/trunk/src/c/toolkits/ToolkitOptions.cpp	(revision 26744)
@@ -8,4 +8,9 @@
 #include "../shared/Exceptions/exceptions.h"
 #include "../shared/MemOps/MemOps.h"
+
+#ifdef _DO_NOT_LOAD_GLOBALS_
+char* ToolkitOptions::toolkittype;
+char* ToolkitOptions::toolkitoptions;
+#endif
 
 void  ToolkitOptions::Init(const char* toolkit_in,const char* options){ /*{{{*/
Index: issm/trunk/src/c/toolkits/codipack/CoDiPackCommon.hpp
===================================================================
--- issm/trunk/src/c/toolkits/codipack/CoDiPackCommon.hpp	(revision 25994)
+++ issm/trunk/src/c/toolkits/codipack/CoDiPackCommon.hpp	(revision 26744)
@@ -35,5 +35,11 @@
 inline void getVectorGradData(const Real* vec, Data* dataVec, int n) {
   for(int i = 0; i < n; ++i) {
-    dataVec[i]=vec[i].getGradientData();
+	 #if _CODIPACK_MAJOR_==2
+    dataVec[i]=vec[i].getIdentifier();
+	 #elif _CODIPACK_MAJOR_==1
+	 dataVec[i]=vec[i].getGradientData();
+	 #else
+	 #error "_CODIPACK_MAJOR_ not supported"
+	 #endif
   }
 }
@@ -43,5 +49,11 @@
   for(int i = 0; i < n; ++i) {
     pasVec[i]=vec[i].getValue();
-    dataVec[i]=vec[i].getGradientData();
+	 #if _CODIPACK_MAJOR_==2
+    dataVec[i]=vec[i].getIdentifier();
+	 #elif _CODIPACK_MAJOR_==1
+	 dataVec[i]=vec[i].getGradientData();
+	 #else
+	 #error "_CODIPACK_MAJOR_ not supported"
+	 #endif
   }
 }
@@ -50,14 +62,32 @@
 inline void getPrimalAndGradData(const Real& value, Passive& pas, Data& data) {
   pas=value.getValue();
+  #if _CODIPACK_MAJOR_==2
+  data=value.getIdentifier();
+  #elif _CODIPACK_MAJOR_==1
   data=value.getGradientData();
+  #else
+  #error "_CODIPACK_MAJOR_ not supported"
+  #endif
 }
 
 template<typename Real, typename Data>
 inline void registerVector(Real* vec, Data* dataVec, int n) {
-  typename Real::TapeType& tape = Real::getGlobalTape();
+	#if _CODIPACK_MAJOR_==2
+	typename Real::Tape& tape = Real::getTape();
+	#elif _CODIPACK_MAJOR_==1
+	typename Real::TapeType& tape = Real::getGlobalTape();
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
 
   for(int i = 0; i < n; ++i) {
     tape.registerInput(vec[i]);
-    dataVec[i]=vec[i].getGradientData();
+	 #if _CODIPACK_MAJOR_==2
+    dataVec[i]=vec[i].getIdentifier();
+	 #elif _CODIPACK_MAJOR_==1
+	 dataVec[i]=vec[i].getGradientData();
+	 #else
+	 #error "_CODIPACK_MAJOR_ not supported"
+	 #endif
   }
 }
Index: issm/trunk/src/c/toolkits/gsl/DenseGslSolve.cpp
===================================================================
--- issm/trunk/src/c/toolkits/gsl/DenseGslSolve.cpp	(revision 25994)
+++ issm/trunk/src/c/toolkits/gsl/DenseGslSolve.cpp	(revision 26744)
@@ -254,16 +254,17 @@
 
 #ifdef _HAVE_CODIPACK_
-void SolverxSeq_codi_b(void* tape_in,void* data_in,void* ra) {/*{{{*/
+#if _CODIPACK_MAJOR_==2
+using Tape = typename IssmDouble::Tape;
+using AccessInterface = codi::VectorAccessInterface<typename Tape::Real, typename Tape::Identifier>;
+void SolverxSeq_codi_b(Tape* tape,void* data_in, AccessInterface* ra) {/*{{{*/
 
 	/*recast data_in and tape*/
-	codi::DataStore* data = (codi::DataStore*)data_in;
-	//IssmDouble::TapeType& tape = (IssmDouble::TapeType&)tape_in;
-	IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+	codi::ExternalFunctionUserData* data = (codi::ExternalFunctionUserData*)data_in;
 
   IssmDouble::Real* valueATrans;
-  IssmDouble::GradientData* indexATrans;
-  IssmDouble::GradientData* indexB;
+  IssmDouble::Identifier* indexATrans;
+  IssmDouble::Identifier* indexB;
   IssmDouble::Real* valueX;
-  IssmDouble::GradientData* indexX;
+  IssmDouble::Identifier* indexX;
   int n;
 
@@ -275,17 +276,16 @@
   data->getData(n);
 
-
   // create the adjoint vector for x and reset the adjoint values on the tape
-  IssmDouble::GradientValue* adjX = xNew<IssmDouble::GradientValue>(n);
-  getVectorAdjoint(tape, indexX, adjX, n);
-
-  IssmDouble::GradientValue* sol  = xNew<IssmDouble::GradientValue>(n);
+  IssmDouble::Gradient* adjX = xNew<IssmDouble::Gradient>(n);
+  getVectorAdjoint(*tape, indexX, adjX, n);
+
+  IssmDouble::Gradient* sol  = xNew<IssmDouble::Gradient>(n);
   SolverxSeq(sol, valueATrans, adjX, n);
 
-  updateVectorAdjoint(tape, indexB, sol, n);
+  updateVectorAdjoint(*tape, indexB, sol, n);
   for(int i=0; i<n; ++i) {
     for (int j=0; j<n; ++j) {
       // we access the transposed matrix here because we stored the indices in a transposed way
-      updateAdjoint(tape, indexATrans[i*n+j], -sol[j]*valueX[i]);
+      updateAdjoint(*tape, indexATrans[i*n+j], -sol[j]*valueX[i]);
     }
   }
@@ -295,14 +295,14 @@
 }
 /*}}}*/
-void SolverxSeq_codi_delete(void* tape_in,void* data_in) {/*{{{*/
+void SolverxSeq_codi_delete(Tape* tape,void* data_in) {/*{{{*/
 
 	/*recast data_in*/
-	codi::DataStore* data = (codi::DataStore*)data_in;
+	codi::ExternalFunctionUserData* data = (codi::ExternalFunctionUserData*)data_in;
 
   IssmDouble::Real* valueATrans;
-  IssmDouble::GradientData* indexATrans;
-  IssmDouble::GradientData* indexB;
+  IssmDouble::Identifier* indexATrans;
+  IssmDouble::Identifier* indexB;
   IssmDouble::Real* valueX;
-  IssmDouble::GradientData* indexX;
+  IssmDouble::Identifier* indexX;
   int n;
 
@@ -319,18 +319,18 @@
   xDelete(valueX);
   xDelete(indexX);
- 
+
   delete data;
 }
 /*}}}*/
 void SolverxSeq(IssmDouble *X,IssmDouble *A,IssmDouble *B,int n, Parameters* parameters){/*{{{*/
-  IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
-  codi::DataStore* dataHandler = NULL;
+  IssmDouble::Tape& tape = IssmDouble::getTape();
+  codi::ExternalFunctionUserData* dataHandler = NULL;
 
   if(tape.isActive()) {
-    dataHandler = new codi::DataStore();
+    dataHandler = new codi::ExternalFunctionUserData();
 
     // create the index vector and the double data for A and B
     IssmDouble::Real* valueATrans = xNew<IssmDouble::Real>(n*n);
-    IssmDouble::GradientData* indexATrans = xNew<IssmDouble::GradientData>(n*n);
+    IssmDouble::Identifier* indexATrans = xNew<IssmDouble::Identifier>(n*n);
 
     // read the data for matrix in a transposed fashion
@@ -342,5 +342,5 @@
 
     // read the data from B (primal values are not required vor B
-    IssmDouble::GradientData* indexB = xNew<IssmDouble::GradientData>(n);
+    IssmDouble::Identifier* indexB = xNew<IssmDouble::Identifier>(n);
     getVectorGradData(B, indexB, n);
 
@@ -366,5 +366,5 @@
   if(tape.isActive()) {
     // create the index vector X and register x as active variables
-    IssmDouble::GradientData* indexX = xNew<IssmDouble::GradientData>(n);
+    IssmDouble::Identifier* indexX = xNew<IssmDouble::Identifier>(n);
     registerVector(X, indexX, n);
 
@@ -375,5 +375,5 @@
     dataHandler->addData(n);
 
-    tape.pushExternalFunctionHandle(&SolverxSeq_codi_b, dataHandler, &SolverxSeq_codi_delete);
+	 tape.pushExternalFunction(codi::ExternalFunction<Tape>::create(&SolverxSeq_codi_b,(void*)dataHandler, &SolverxSeq_codi_delete));
   }
   else{
@@ -386,4 +386,140 @@
 }
 /*}}}*/
+#elif _CODIPACK_MAJOR_==1
+void SolverxSeq_codi_b(void* tape_in,void* data_in,void* ra) {/*{{{*/
+
+	/*recast data_in and tape*/
+	codi::DataStore* data = (codi::DataStore*)data_in;
+	//IssmDouble::TapeType& tape = (IssmDouble::TapeType&)tape_in;
+	IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+
+	IssmDouble::Real* valueATrans;
+	IssmDouble::GradientData* indexATrans;
+	IssmDouble::GradientData* indexB;
+	IssmDouble::Real* valueX;
+	IssmDouble::GradientData* indexX;
+	int n;
+
+	data->getData(valueATrans);
+	data->getData(indexATrans);
+	data->getData(indexB);
+	data->getData(valueX);
+	data->getData(indexX);
+	data->getData(n);
+
+
+	// create the adjoint vector for x and reset the adjoint values on the tape
+	IssmDouble::GradientValue* adjX = xNew<IssmDouble::GradientValue>(n);
+	getVectorAdjoint(tape, indexX, adjX, n);
+
+	IssmDouble::GradientValue* sol  = xNew<IssmDouble::GradientValue>(n);
+	SolverxSeq(sol, valueATrans, adjX, n);
+
+	updateVectorAdjoint(tape, indexB, sol, n);
+	for(int i=0; i<n; ++i) {
+		for (int j=0; j<n; ++j) {
+			// we access the transposed matrix here because we stored the indices in a transposed way
+			updateAdjoint(tape, indexATrans[i*n+j], -sol[j]*valueX[i]);
+		}
+	}
+
+	xDelete(sol);
+	xDelete(adjX);
+}
+/*}}}*/
+void SolverxSeq_codi_delete(void* tape_in,void* data_in) {/*{{{*/
+
+	/*recast data_in*/
+	codi::DataStore* data = (codi::DataStore*)data_in;
+
+	IssmDouble::Real* valueATrans;
+	IssmDouble::GradientData* indexATrans;
+	IssmDouble::GradientData* indexB;
+	IssmDouble::Real* valueX;
+	IssmDouble::GradientData* indexX;
+	int n;
+
+	data->getData(valueATrans);
+	data->getData(indexATrans);
+	data->getData(indexB);
+	data->getData(valueX);
+	data->getData(indexX);
+	data->getData(n);
+
+	xDelete(valueATrans);
+	xDelete(indexATrans);
+	xDelete(indexB);
+	xDelete(valueX);
+	xDelete(indexX);
+
+	delete data;
+}
+/*}}}*/
+void SolverxSeq(IssmDouble *X,IssmDouble *A,IssmDouble *B,int n, Parameters* parameters){/*{{{*/
+	IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+	codi::DataStore* dataHandler = NULL;
+
+	if(tape.isActive()) {
+		dataHandler = new codi::DataStore();
+
+		// create the index vector and the double data for A and B
+		IssmDouble::Real* valueATrans = xNew<IssmDouble::Real>(n*n);
+		IssmDouble::GradientData* indexATrans = xNew<IssmDouble::GradientData>(n*n);
+
+		// read the data for matrix in a transposed fashion
+		for (int i=0; i<n; ++i) {
+			for (int j=0; j<n; ++j) {
+				getPrimalAndGradData(A[i*n+j], valueATrans[j*n+i], indexATrans[j*n+i]);
+			}
+		}
+
+		// read the data from B (primal values are not required vor B
+		IssmDouble::GradientData* indexB = xNew<IssmDouble::GradientData>(n);
+		getVectorGradData(B, indexB, n);
+
+		dataHandler->addData(valueATrans);
+		dataHandler->addData(indexATrans);
+		dataHandler->addData(indexB);
+	}
+
+	// unpack the primal values from the matrix and the vector
+	IssmDouble::Real* valueA = xNew<IssmDouble::Real>(n*n);
+	IssmDouble::Real* valueB = xNew<IssmDouble::Real>(n);
+	// read the data from A and B
+	getVectorPrimal(A, valueA, n*n);
+	getVectorPrimal(B, valueB, n);
+
+	// create the placeholder for X and solve the system
+	IssmDouble::Real* valueX = xNew<IssmDouble::Real>(n);
+	SolverxSeq(valueX, valueA, valueB, n);
+
+	// pack the values into x
+	setVectorPrimal(X, valueX, n);
+
+	if(tape.isActive()) {
+		// create the index vector X and register x as active variables
+		IssmDouble::GradientData* indexX = xNew<IssmDouble::GradientData>(n);
+		registerVector(X, indexX, n);
+
+		dataHandler->addData(valueX);
+		dataHandler->addData(indexX);
+
+		// store other arguments
+		dataHandler->addData(n);
+
+		tape.pushExternalFunctionHandle(&SolverxSeq_codi_b, dataHandler, &SolverxSeq_codi_delete);
+	}
+	else{
+		// if the tape is active valueX is stored in the dataHandler and deleted in the reverse sweep
+		xDelete(valueX);
+	}
+
+	xDelete(valueB);
+	xDelete(valueA);
+}
+/*}}}*/
+#else
+#error "_CODIPACK_MAJOR_ not supported"
+#endif
 void DenseGslSolve(/*output*/ IssmDouble** px,/*stiffness matrix:*/ IssmDouble* Kff, int Kff_M, int Kff_N, /*right hand side load vector: */ IssmDouble* pf, int pf_M, Parameters* parameters){ /*{{{*/
 
@@ -401,3 +537,4 @@
 }
 /*}}}*/
-#endif
+
+#endif
Index: issm/trunk/src/c/toolkits/issm/Bucket.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/Bucket.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/issm/Bucket.h	(revision 26744)
@@ -34,37 +34,78 @@
 			this->Initialize();
 		} /*}}}*/
-		Bucket(int min,int* idxmin,int nin,int* idxnin,doubletype* valuesin,InsMode modein){ /*{{{*/
+		Bucket(int m_in,int* idxm_in,int n_in,int* idxn_in,doubletype* values_in,InsMode mode_in){ /*{{{*/
 
 			this->Initialize();
 
+			/*Check whether we have negative indices?*/
+			int m_numneg = 0;
+			int n_numneg = 0;
+			for(int i=0;i<m_in;i++) if(idxm_in[i]<0) m_numneg++;
+			for(int i=0;i<n_in;i++) if(idxn_in[i]<0) n_numneg++;
+
 			this->type=MATRIX_BUCKET;
-			this->m=min;
-			this->n=nin;
-			this->mode=modein;
+			this->m=m_in-m_numneg;
+			this->n=n_in-n_numneg;
+			this->mode=mode_in;
+			if(this->m*this->n){
+				this->idxm=xNew<int>(this->m); 
+				this->idxn=xNew<int>(this->n); 
+				this->values=xNew<doubletype>(this->n*this->m);
+
+				if(m_numneg==0 && n_numneg==0){
+					xMemCpy(this->values,values_in,this->n*this->m);
+					xMemCpy(this->idxm,idxm_in,this->m);
+					xMemCpy(this->idxn,idxn_in,this->n);
+				}
+				else{
+					int count;
+					count =0; for(int i=0;i<m_in;i++) if(idxm_in[i]>=0) this->idxm[count++] = idxm_in[i];
+					count =0; for(int i=0;i<n_in;i++) if(idxn_in[i]>=0) this->idxn[count++] = idxn_in[i];
+					count = 0;
+					for(int i=0;i<m_in;i++){
+						if(idxm_in[i]>=0){
+							for(int j=0;j<n_in;j++){
+								if(idxn_in[j]>=0){
+									this->values[count++] = values_in[i*n_in+j];
+								}
+							}
+						}
+					}
+				}
+			}
+			else{
+				/*Set both as 0 to save time*/
+				this->m = 0;
+				this->n = 0;
+			}
+		} /*}}}*/
+		Bucket(int m_in,int* idxm_in,doubletype* values_in,InsMode mode_in){ /*{{{*/ 
+			this->Initialize();
+
+			/*Check whether we have negative indices?*/
+			int numneg = 0;
+			for(int i=0;i<m_in;i++) if(idxm_in[i]<0) numneg++;
+
+			this->type=VECTOR_BUCKET; 
+			this->m=m_in-numneg;
+			this->mode=mode_in;
 			if(this->m){
-				this->idxm=xNew<int>(this->m); 
-				xMemCpy(this->idxm,idxmin,this->m);
-			}
-			if(this->n){
-				this->idxn=xNew<int>(this->n); 
-				xMemCpy(this->idxn,idxnin,this->n);
-			}
-			if(this->m*this->n){
-				this->values=xNew<doubletype>(this->n*this->m);
-				xMemCpy(this->values,valuesin,this->n*this->m);
-			}
-		} /*}}}*/
-		Bucket(int min,int* idxmin,doubletype* valuesin,InsMode modein){ /*{{{*/ 
-			this->Initialize();
-
-			this->type=VECTOR_BUCKET; 
-			this->m=min;
-			this->mode=modein;
-			if(this->m){
-				this->idxm=xNew<int>(this->m); 
-				xMemCpy(this->idxm,idxmin,this->m);
-
+				this->idxm=xNew<int>(this->m);
 				this->values=xNew<doubletype>(this->m);
-				xMemCpy(this->values,valuesin,this->m);
+
+				if(numneg==0){
+					xMemCpy(this->idxm,idxm_in,this->m);
+					xMemCpy(this->values,values_in,this->m);
+				}
+				else{
+					int count = 0;
+					for(int i=0;i<m_in;i++){
+						if(idxm_in[i]>=0){
+							this->idxm[count]   = idxm_in[i];
+							this->values[count] = values_in[i];
+							count++;
+						}
+					}
+				}
 			}
 		} /*}}}*/
@@ -88,5 +129,5 @@
 		/*object virtual functions definitions:*/
 		void    Echo(){ /*{{{*/
-			_printf_("Bucket echo (cpu #: "<<IssmComm::GetRank()<<")\n");
+			_printf_("Bucket echo (cpu #"<<IssmComm::GetRank()<<")\n");
 			_printf_("bucket type: " << type << "\n");
 			_printf_("num rows: "<<this->m<<" num cols: "<<this->n << "\n");
@@ -95,5 +136,5 @@
 			int i,j;
 
-			_printf_("Bucket echo (cpu #: "<<IssmComm::GetRank()<<")\n");
+			_printf_("Bucket echo (cpu #"<<IssmComm::GetRank()<<")\n");
 			_printf_("bucket type: " << type << "\n");
 			_printf_("num rows: "<<this->m<<" num cols: "<<this->n << "\n");
Index: issm/trunk/src/c/toolkits/issm/IssmAbsVec.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmAbsVec.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/issm/IssmAbsVec.h	(revision 26744)
@@ -52,4 +52,5 @@
 		virtual void PointwiseMult(IssmAbsVec* x,IssmAbsVec* y)=0;
 		virtual void Pow(doubletype scale_factor)=0;
+		virtual void Sum(doubletype* pvalue)=0;
 };
 
Index: issm/trunk/src/c/toolkits/issm/IssmDenseMat.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmDenseMat.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/issm/IssmDenseMat.h	(revision 26744)
@@ -161,4 +161,6 @@
 					break;
 			}
+
+			return 0.;
 		}
 		/*}}}*/
@@ -230,8 +232,20 @@
 			switch(mode){
 				case ADD_VAL:
-					for(i=0;i<m;i++) for(j=0;j<n;j++) this->matrix[N*idxm[i]+idxn[j]]+=values[n*i+j];
+					for(i=0;i<m;i++){
+						if(idxm[i]<0) continue;
+						for(j=0;j<n;j++){
+							if(idxn[j]<0) continue;
+							this->matrix[N*idxm[i]+idxn[j]]+=values[n*i+j];
+						}
+					}
 					break;
 				case INS_VAL:
-					for(i=0;i<m;i++) for(j=0;j<n;j++) this->matrix[N*idxm[i]+idxn[j]]=values[n*i+j];
+					for(i=0;i<m;i++){
+						if(idxm[i]<0) continue;
+						for(j=0;j<n;j++){
+							if(idxn[j]<0) continue;
+							this->matrix[N*idxm[i]+idxn[j]]=values[n*i+j];
+						}
+					}
 					break;
 				default:
Index: issm/trunk/src/c/toolkits/issm/IssmMpiDenseMat.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmMpiDenseMat.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/issm/IssmMpiDenseMat.h	(revision 26744)
@@ -339,4 +339,6 @@
 					break;
 			}
+
+			return 0.;
 		}
 		/*}}}*/
Index: issm/trunk/src/c/toolkits/issm/IssmMpiSparseMat.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmMpiSparseMat.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/issm/IssmMpiSparseMat.h	(revision 26744)
@@ -90,5 +90,5 @@
 		/*}}}*/
 		void Init(int Min,int Nin){/*{{{*/
-			
+
 			this->buckets=new DataSet();
 
@@ -288,5 +288,5 @@
 				}
 			}
-					
+
 			/*Plug into matrix: */
 			for(int i=0;i<this->m;i++) this->matrix[i]->SetValues(numvalues_perrow[i],cols_perrow[i],values_perrow[i],mods_perrow[i]);
@@ -362,4 +362,6 @@
 					break;
 			}
+
+			return 0.;
 		}
 		/*}}}*/
Index: issm/trunk/src/c/toolkits/issm/IssmMpiVec.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmMpiVec.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/issm/IssmMpiVec.h	(revision 26744)
@@ -444,5 +444,4 @@
 			comm=IssmComm::GetComm();
 			num_procs=IssmComm::GetSize();
-
 
 			/*Allocate: */
@@ -528,4 +527,5 @@
 					break;
 			}
+			return 0.;
 		}
 		/*}}}*/
@@ -592,4 +592,8 @@
 			for(i=0;i<this->M;i++)this->vector[i]=pow(this->vector[i],scale_factor);
 
+		}
+		/*}}}*/
+		void Sum(doubletype* pvalue){/*{{{*/
+			_error_("not support yet!");
 		}
 		/*}}}*/
Index: issm/trunk/src/c/toolkits/issm/IssmSeqVec.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmSeqVec.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/issm/IssmSeqVec.h	(revision 26744)
@@ -101,8 +101,8 @@
 			switch(mode){
 				case ADD_VAL:
-					for(i=0;i<ssize;i++) this->vector[list[i]]+=values[i];
+					for(i=0;i<ssize;i++) if(list[i]>=0) this->vector[list[i]]+=values[i];
 					break;
 				case INS_VAL:
-					for(i=0;i<ssize;i++) this->vector[list[i]]=values[i];
+					for(i=0;i<ssize;i++) if(list[i]>=0) this->vector[list[i]]=values[i];
 					break;
 				default:
@@ -113,5 +113,7 @@
 		}
 		/*}}}*/
-		void SetValue(int dof, doubletype value, InsMode mode){/*{{{*/
+		void SetValue(int dof, doubletype value,InsMode mode){/*{{{*/
+
+			_assert_(dof>=0);
 
 			switch(mode){
@@ -263,4 +265,6 @@
 					break;
 			}
+
+			return 0.;
 		}
 		/*}}}*/
@@ -324,4 +328,12 @@
 		}
 		/*}}}*/
+		void Sum(doubletype* pvalue){/*{{{*/
+
+			doubletype value=0;
+			int i;
+			for(i=0;i<this->M;i++)value+=this->vector[i];
+			*pvalue=value;
+		}
+		/*}}}*/
 
 };
Index: issm/trunk/src/c/toolkits/issm/IssmVec.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmVec.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/issm/IssmVec.h	(revision 26744)
@@ -220,4 +220,8 @@
 		}
 		/*}}}*/
+		void Sum(doubletype*  pvalue){/*{{{*/
+			vector->Sum(pvalue);
+		}
+		/*}}}*/
 };
 
Index: issm/trunk/src/c/toolkits/mpi/issmmpi.h
===================================================================
--- issm/trunk/src/c/toolkits/mpi/issmmpi.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/mpi/issmmpi.h	(revision 26744)
@@ -31,7 +31,19 @@
 			//#define AMPI_ADOUBLE TOOL::MPI_TYPE
 			//
+			//#include <codi/externals/codiMpiTypes.hpp>
+			//using MpiTypes = CoDiMpiTypes<IssmDouble>;
 			/*New implementation*/
+			#if _CODIPACK_MAJOR_==2
+			#include <codi/tools/mpi/codiMpiTypes.hpp>
+			using MpiTypes = codi::CoDiMpiTypes<IssmDouble>;
+
+			#elif _CODIPACK_MAJOR_==1
 			#include <codi/externals/codiMpiTypes.hpp>
 			using MpiTypes = CoDiMpiTypes<IssmDouble>;
+
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
+
 			extern MpiTypes* mpiTypes;
 			#define AMPI_ADOUBLE mpiTypes->MPI_TYPE
